<?php
/* 2019/05/14 Ver1.0
Do not remove this comentout
*/

date_default_timezone_set('Asia/Tokyo');

const FILE_PATH = '/tmp/';  /* order file output destination */
const EC_ID = '1000001';    /* Advertiser ID */
const APPEND_ORDER = false; /* true:append the data to order file  false:overwrite the data to order file */

function createOrderFileInJsonFormat ($order, $isAppend = false, $toEncoding = 'UTF-8', $fromEncoding = 'ASCII,JIS,UTF-8,EUC-JP,SJIS') {
    $flags = 0;
    if ($isAppend) {
        $flags = FILE_APPEND;
        $fileName = EC_ID . '_' . date('Ymd') . '_P.json';
    } else {
        $fileName = substr($order['ORDER_ID'], 0, 248) . '_P.json';
    }

    $filePath = FILE_PATH . $fileName;
    file_put_contents($filePath, mb_convert_encoding(json_encode($order), $toEncoding, $fromEncoding) . PHP_EOL, $flags);
    chmod($filePath, 0666);

    return;
}

function createOrderFile($orderInfo) {
    $order = array();
    foreach($orderInfo as $key => $value) {
        $order[$key] = $value;
    }

    if (!isset($order['FC'])) {
        $fc = '_vc_citi_' . EC_ID;
        if (!empty($_COOKIE[$fc])) {
            $order['FC'] = explode(';', $_COOKIE[$fc])[0];
        }
    }

    $order['EC_ID'] = EC_ID;
    $order['STATUS'] = 'P';
    $order['SALES_DATE'] = date('Y/m/d');
    $order['SALES_TIME'] = date('H:i:s');
    $order['REMOTE_ADDR'] = !empty($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '';
    $order['HTTP_USER_AGENT'] = !empty($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    $order['HTTP_X_FORWARDED_FOR'] = !empty($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : '';
    $order['HTTP_VIA'] = !empty($_SERVER['HTTP_VIA']) ? $_SERVER['HTTP_VIA'] : '';
    $cookieKey = '_vc_cec_' . EC_ID;
    $order['VC_COOKIE'] = !empty($_COOKIE[$cookieKey]) ? explode(';', $_COOKIE[$cookieKey])[0] : '';

    createOrderFileInJsonFormat($order, APPEND_ORDER);

    return;
}

function getParams() {
    $params = [];
    $qstr = filter_input(INPUT_SERVER, 'QUERY_STRING');
    if (empty($qstr)) {
        return $params;
    }
    $queries = explode('&', $qstr);
    foreach ($queries as $query) {
        $keyValue = explode('=', $query, 2);
        $params[strtoupper($keyValue[0])] = $keyValue[1];
    }
    return $params;	
}

# for testing
#$orderInfo = array(
#                   'ORDER_ID'    => '001',
#                   'SALES_NAME'  => '1234567',
#                   'SALES_TEL'   => '*****',
#                   'SALES_EMAIL' => 'gonbe',
#                   'CS'          => 'N',
#                   'UID'         => 'customer12345'
#                  );
#$detail1 = array(
#                 'ITEM_QTY'       => 1,
#                 'ITEM_PRICE'     => 100,
#                 'ITID'           => 'it1',
#                 'PRODUCT_ID'     => 'product1',
#                 'ITEM_NAME'      => 'item1',
#                 'ITEM_PRGRID'    => 'prg1',
#                 'ITEM_DETAIL_ID' => 'detail1'
#                );
#$detail2 = array(
#                 'ITEM_QTY'       => 2,
#                 'ITEM_PRICE'     => 300,
#                 'ITEM_NAME'      => 'item2',
#                 'ITEM_DETAIL_ID' => 'detail2'
#                );
#$orderInfo['DETAIL'][] = $detail1;
#$orderInfo['DETAIL'][] = $detail2;
#
#createOrderFile($orderInfo);
#exit;

# execute php in javascript
#$orderInfo = getParams();
#if (!empty($orderInfo)) {
#    createOrderFile($orderInfo);
#}
#exit;

?>

